<?php
/*======================================================================*\
|| #################################################################### ||
|| # Package - JBootstrap                								||
|| # Copyright (C) since 2007  Youjoomla.com. All Rights Reserved.      ||
|| # license - PHP files are licensed under  GNU/GPL V2                 ||
|| # license - CSS  - JS - IMAGE files  are Copyrighted material        || 
|| # websites - http://www.youjoomla.com | http://www.yjsimplegrid.com  ||
|| #################################################################### ||
\*======================================================================*/

// no direct access 
if((int)JVERSION == 3){
	defined('JPATH_PLATFORM') or die;
}else{
	defined('_JEXEC') or die ('Restricted access');
}

jimport( 'joomla.plugin.plugin');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

// Initiate class to hold plugin events  
class plgSystemJBootstrap extends JPlugin{

	public $yjsg_check 			= 0;
	
	public $plugin_dir 			= "";

	public $default_template 	= "";
	
	function __construct(&$subject, $config){
	
		if((int)JVERSION == 3){
			return ;
		}	
	
		parent::__construct($subject, $config);
		$this->loadLanguage();
		$this->plugin_dir = JPATH_SITE.DIRECTORY_SEPARATOR."plugins".DIRECTORY_SEPARATOR.'system'.DIRECTORY_SEPARATOR."JBootstrap".DIRECTORY_SEPARATOR;
		
		
		// Create a new query object.
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true);

		// Select the required fields from the table.
		$query->select('a.template');
		$query->from($db->quoteName('#__template_styles').' AS a');
		$query->where('a.home = 1');
		$query->where('a.client_id = 0');
		
		$db->setQuery($query);
		$default_template = $db->loadResult();

		// Make sure there aren't any errors
		if ($db->getErrorNum()) {
			echo $db->getErrorMsg();
			exit;
		}

		$this->default_template = $default_template;
		
		$yjsg_dork = JPATH_SITE.DIRECTORY_SEPARATOR."templates".DIRECTORY_SEPARATOR.$this->default_template.DIRECTORY_SEPARATOR."yjsgcore".DIRECTORY_SEPARATOR."lib".DIRECTORY_SEPARATOR."lessc.inc.php";		
		if(JFile::exists($yjsg_dork)){
			$this->yjsg_check = 1;
		}
	}

	/**
	 * add the bootstrap class
	 */
	public function onAfterRoute (){

		$app = JFactory::getApplication();
		//include the bootstrap class
		if (!$app->isAdmin() && !class_exists('JHtmlBootstrap')){ 
			require_once $this->plugin_dir."lib".DIRECTORY_SEPARATOR."cms".DIRECTORY_SEPARATOR."html".DIRECTORY_SEPARATOR."jquery.php";
			require_once $this->plugin_dir."lib".DIRECTORY_SEPARATOR."cms".DIRECTORY_SEPARATOR."html".DIRECTORY_SEPARATOR."bootstrap.php";
		}	
	}
	
	/**
	 * remove the Joomla tips and change pagination class
	 */
	public function onAfterInitialise(){
		//$document 	= JFactory::getDocument();
		//$yjsg_check = JPATH_SITE.DIRECTORY_SEPARATOR."templates".DIRECTORY_SEPARATOR.$document->template.DIRECTORY_SEPARATOR."yjsgcore".DIRECTORY_SEPARATOR."lib".DIRECTORY_SEPARATOR."lessc.inc.php";

		if((int)JVERSION == 3){
			JPluginHelper::importPlugin('system');
			$dispatcher = JEventDispatcher::getInstance();
			$dispatcher->detach('plgSystemJBootstrap');
			return ;
		}

		if(!JFactory::getApplication()->isAdmin() && $this->yjsg_check == 1){
		
			
			// delete yj css cache files force recompile
			require_once $this->plugin_dir."lib".DIRECTORY_SEPARATOR."yjpagenav.php";	
			
			if((int)JVERSION == 2){
				JHtml::register('behavior.tooltip', array('plgSystemJBootstrap','notooltip'));
			}
			
			JPluginHelper::importPlugin('content');
			if((int)JVERSION == 3){
				$dispatcher = JEventDispatcher::getInstance();
			}else{
				$dispatcher = JDispatcher::getInstance();
			}
			$dispatcher->detach('plgContentPagenavigation');
			
			$observer = array();
			$observer['handler']  = "YJPagenavigation";
			$observer['event']  = "oncontentbeforedisplay";
			$dispatcher->attach($observer);		
		}
	}

	/**
	 * remove Joomla tooltips function
	 */	
	public function notooltip($selector = '', $params = array()){
		return;
	}


	/**
	 *recompile less files
	 */ 
	public function onBeforeCompileHead(){ 
		$app = JFactory::getApplication();

		if(!$app->isAdmin()){
			//VM rearange the js file
			$document 	= JFactory::getDocument();
			$last_array	= array();
			$bs_found 	= false;

			
			
			// k2 jquery load check
			$k2check = JPluginHelper::getPlugin('system', 'k2');
			$unsetjq = false;
			
			if($k2check){
				$k2params = $app->getParams('com_k2');
				$k2jq = str_replace('remote','',$k2params->get('jQueryHandling'));
				if($k2check && version_compare($k2jq, '1.8.1', '>=')) {
					
					$unsetjq = true;
					
				}
				
				
			}
			
			
			foreach($document->_scripts as $scripts_path => $file){
				
				if(strstr($scripts_path, 'bootstrap.min.js') && $bs_found == false){
					array_unshift($last_array, array($scripts_path => $file));
					unset($document->_scripts[$scripts_path]);			
					$bs_found = true;
					continue;
				}
				if(strstr($scripts_path, 'com_virtuemart') || $bs_found == true){
					$last_array[] = array($scripts_path => $file);
					unset($document->_scripts[$scripts_path]);
				}
				
				if($unsetjq) {
					unset($document->_scripts[JUri::root(true) . '/media/jui/js/jquery.min.js']);
					unset($document->_scripts[JUri::root(true) . '/media/jui/js/jquery-noconflict.js']);
				}
				// if k2 jquery is disabeled , move the k2.js file below jquery, should have been checked by the developers
				if($k2check){
					
					if($k2jq == 0 && strstr($scripts_path, 'k2.js')){
						$last_jsfiles_array[] = array($scripts_path => $file);
						unset($document->_scripts[$scripts_path]);
					}					
				}
				
			}
			
			foreach($last_array as $head_file){
				$document->_scripts[key($head_file)] = $head_file[key($head_file)];
			}
		}

		//run the compiler only if it's activated and app is not admin
		if(!$app->isAdmin() && $this->params->get('active', 0) == 1 && $this->yjsg_check == 0){
			
			// define default vars
			$lib_dir 			= $this->plugin_dir.DIRECTORY_SEPARATOR."lib".DIRECTORY_SEPARATOR;
			$less_dir 			= JPATH_SITE.DIRECTORY_SEPARATOR."templates".DIRECTORY_SEPARATOR.$this->default_template.DIRECTORY_SEPARATOR."less".DIRECTORY_SEPARATOR;
			$input_less			= $less_dir.$this->params->get('input_file', 'template').".less";
			$output_folder		= $this->params->get('output_folder', 'css');
			$css_dir  			= JPATH_SITE.DIRECTORY_SEPARATOR."templates".DIRECTORY_SEPARATOR.$this->default_template.DIRECTORY_SEPARATOR.$output_folder.DIRECTORY_SEPARATOR;
			$output_css			= $css_dir.$this->params->get('output_file', 'template').".css";
			$compile_css		= $this->params->get('compile_css', 1);
			$compress_outcss	= $this->params->get('compress_outcss', 0);

			if(JFolder::exists($less_dir)){
				//check less folder and make sure there is no other less class
				if(!class_exists('lessc')){
					require_once "lib/lessc.inc.php";
					require_once "lib/lessphpcss.inc.php";
					require_once "lib/lessphpcache.inc.php";
				}
				
				//check less class and folder first 
				if(class_exists('lessPhpCss') && $compile_css == 1){
					$less 				= new lessPhpCss;
				}elseif(class_exists('lessPhpCache')){
					$less 				= new lessPhpCache;
				}
	
				// compress output 
				if($compress_outcss == 1){
					$less->setFormatter("compressed");
				}
				
				// load the cache
				$cacheFile = $lib_dir.'temp.php'; 
			
				if (file_exists($cacheFile)){
					include_once $cacheFile;
					$cache = unserialize($BSCache);
				} else {
					$cache = $input_less;
				}
	
				$newCache = $less->cachedCompile($cache);
				
				if (!is_array($cache) || $newCache["updated"] > $cache["updated"] || !file_exists($output_css)) {
					try {
						$less->compileFile($input_less,$output_css);
					} catch (exception $e) {
						JError::raiseWarning( 100, JText::_('PLG_SYSTEM_JBOOTSTRAP_LESS_COMPILER_ERROR').'<br />'.$e->getMessage());
					}
					$newCache['files'] = $less->allParsedFiles();
					$writeValue = "<?php defined('JPATH_PLATFORM') or die; \$BSCache = '".serialize($newCache)."'; ?>";
					file_put_contents($cacheFile, $writeValue);
				}			
			}else{
				JError::raiseWarning( 100, JText::_('PLG_SYSTEM_JBOOTSTRAP_LESS_COMPILER_ERROR'));
			}		
		}
	}
	 
	/**
	 * check to see if we have to restore backup files
	 */ 	 
	public function onExtensionBeforeSave($name, $data){

		// clean cache on save 
		$lib_dir 			= $this->plugin_dir.DIRECTORY_SEPARATOR."lib".DIRECTORY_SEPARATOR;
		$cacheFile 			= $lib_dir.'temp.php';
		if(JFile::exists($cacheFile)) {
			JFile::delete($cacheFile);
		}
		
		$params 	= new JRegistry();
		if((int)JVERSION == 3){
			$params->loadString($data->params);
		}else{
			$params->loadJSON($data->params);
		}

		//restore all backup files
		if($params->get('restore_backup', 0) == 1){
			jimport('joomla.filesystem.file');
			jimport('joomla.filesystem.folder');
			
			//read all the backups files
			$restore_files = JFolder::files($this->plugin_dir."backups",".css");
			if(is_array($restore_files) && !empty($restore_files)){
			
				if($this->yjsg_check == 0):
					$app = JFactory::getApplication();				
					foreach($restore_files as $file){
						//move the file back to the original location
						if($file != "" && filesize($this->plugin_dir."backups".DIRECTORY_SEPARATOR.$file) > 0){
							$restore_path = str_replace("_dir_","/",$file);
							JFile::delete(JPATH_SITE.DIRECTORY_SEPARATOR."templates".DIRECTORY_SEPARATOR.$this->default_template.DIRECTORY_SEPARATOR.$restore_path);						
							if(JFile::copy($this->plugin_dir."backups".DIRECTORY_SEPARATOR.$file, JPATH_SITE.DIRECTORY_SEPARATOR."templates".DIRECTORY_SEPARATOR.$this->default_template.DIRECTORY_SEPARATOR.$restore_path)){
								$app->enqueueMessage(JText::_('PLG_SYSTEM_JBOOTSTRAP_RESTORE_SUCCESSFULLY'));
							}
						}else{
							$app->enqueueMessage(JText::_('PLG_SYSTEM_JBOOTSTRAP_INVALID_BACKUP_FILE'),'error');
						}
					}
				endif;// end yjsg check
			}
			
			//put the restore param back to value 0, so we don't restore backup next time user saves the plugin
			$params->set('restore_backup', 0);
			$data->params = $params->__toString();
		}
		
		return true;
	}	
	
} // END CLASS